import edu.wsu.KheperaSimulator.RobotController;
import edu.wsu.KheperaSimulator.KSGripperStates;

public class AvoidLights extends RobotController{
	int distance = 700;
	int light = 200;
	int counter =0;
	boolean turnLeft;
	double randomNo1;
	double randomNo2;
	
	public void doWork(){
		//Testing spanking new navigation system.
		counter ++;
		if(counter > 50){
			randomNo1 = Math.random();
			randomNo2 = Math.random();
			counter = 0;
		}
		
		if(randomNo1 < 0.1){
			if(randomNo2 > 0.5){
				turnRight();
			}else{
				turnLeft();
			}
		}else
			goForward();

			
			while(light()){
				if(randomNo2 < 0.50){
					turnRight();
				}else
					turnLeft();
			}
			
			while(obstructed()){
				if(randomNo2 > 0.5){
					turnRight();
				}
				else
					turnLeft();
			}
		
		
		
		/* Old implementation:
		if(Math.random() < 0.1){
			if(Math.random() > 0.5){
				turnRight();
			}else{
				System.out.println("Hallelujah!");
				turnLeft();
			}
			
		}
		
		if(light()){
			if(Math.random()>0.50){
				turnRight();
			}else
				turnLeft();
		}
		
		if(obstructed()){
			if(Math.random()>0.5){
				turnRight();
			}
			else
				turnLeft();
		*/
	}
	
	public void turnLeft(){
		//System.err.println("ARHHHHH!! LEFT!");
		setMotorSpeeds(-2,2);
	}
	
	
	
	public void close(){}
	
	public void back(){
		setMotorSpeeds(-2,-2);
	}
	
	public void turnRight(){
		setMotorSpeeds(2,-2); 
	}
	
	
	public void goForward(){
		setMotorSpeeds(2,2);
	}
	
	public boolean obstructed(){
		if(getDistanceValue(6) > distance || getDistanceValue(5) > distance || getDistanceValue(4) > distance || getDistanceValue(3) > distance || getDistanceValue(2) > distance || getDistanceValue(1) > distance){
			return true;
		}else{
			return false;
		}
	}
	
	public boolean light(){
		if(getLightValue(3) < light || getLightValue(4) < light){
			//System.err.println("LIIIGHT LIIIIIIIIIGHT!");
			return true;
		}else{
			return false;
		}
	}

	
}
