<? if($type == 1) { $counter =  $task + 7; }else{ $counter =  $task + 5; } ?>
<style type="text/css">
<!--
.style1 {color: #00FF00}
-->
</style>
<h2><?  echo $counter ?>. Task <? echo $task; ?> - Implement a Watchdog Pattern </h2>
<p>&nbsp;</p>

  <form id="form2" name="form2" method="post" action="timer.php?TASK=<? echo $task; ?>&TYPE=start">
    Start the timer
    <input type="submit" name="auto" value="Start" />
(or enter start time HH:MM manually:
<input name="hour" type="text" id="start_text" size="2" maxlength="2" />
:
<input name="minutes" type="text" id="start_text2" size="2" maxlength="2" />
<input type="submit" name="manual" value="Enter" />
) when you are ready to start the programming task: 
	<? if($start && $start !== "00:00:00"){ ?>
		<span class="style1">Stored start time: <b><? echo $start; ?></b></span>
	<?
		}
	?>
</form>
<p>&nbsp;</p>
<p><strong>Abstract</strong></p>
<p>A <em>watchdog</em>, used in common computing parlance, is a component that watches out over processing of another component. Its job is to make sure that nothing obviously is wrong.</p>
<p>&nbsp;</p>
<p>The <em>Actuator Channel</em> operates pretty much independently of the watchdog, sening a liveness message every so often to the watchdog. This is called stroking the watchdog.</p>
<p>&nbsp;</p>
<p>The watchdog uses the timeliness of the stoking to determine whether a fault has occurred.  </p>
<p>&nbsp;</p>
  <p><img src="images/watchdog.jpg" /></p>
  <p><strong>Implementation</strong></p>
  <p>A watchdog pattern that uses<em> System.currentTimeMills()</em> as a timebase has been implemented in the Java class <a href="./Watchdog.java">Watchdog.java</a>. </p>
  <p>&nbsp;</p>
  <p>The watchdog get initialized to a defined timelimit (in milliseconds):</p>
  <p><img src="images/initWatchdog.jpg" width="537" height="148" border="1" /></p>
  <p>&nbsp;</p>
  <p>To check the state of the watchdog, the<strong> getState()</strong> method returns <em>false</em> if a stroke is absent within the timelimit:</p>
  <p><img src="images/WatchdogStatus.jpg"  border="1" /></p>
  <div align="left">
    <p>&nbsp;</p>

    <p><strong>Your task is to :</strong></p>
    <ol>
      <li><p>Extend the Channel class to use the Watchdog class in addition to the RobotController. </p></li>
      <li><p>Add a method in the Channel class that also checks the RobotController <strong>getRightWheelPosition()</strong> and <strong>getLeftWheelPosition()</strong> , so that a stroke is sent to the watchdog every time the robot wheel positions are changing.</p></li>
      <li>
        <p>Add a test in the main controller class (from the solution of your last task) that checks the watchdog state, and if the state is false (robot is stuck), an attempt to get the robot free from the obstacle should be done. Define a appropriate timelimit (example 5 seconds = 5000 ms). </p>
      </li>
    </ol>
    <ol>
    </ol>
    <form id="form3" name="form3" method="post" action="timer.php?TASK=<? echo $task; ?>&TYPE=stop">
      Stop the timer
      <input type="submit" name="auto" value="Stop" />
(Or enter stop time HH:MM manually
<input name="hour" type="text" id="hour" size="2" maxlength="2" />
:
<input name="minutes" type="text" id="minutes" size="2" maxlength="2" />
<input type="submit" name="manual" value="Enter" />
) when you are finished programming: 
<? if($stop && $stop !== "00:00:00"){ ?>
				<span class="style1">Stored stop time: <b><? echo $stop; ?></b></span>
			<?
		}
?>
    </form>
</div>
  <form enctype="multipart/form-data" action="upload.php?TASK=<? echo $task; ?>" method="post">
    <p>
      <input type="hidden" name="MAX_FILE_SIZE" value="100000" />
    </p>
	  <p>&nbsp;</p>
    <p>Upload the source code from (1), (2) and (3) in the package "Task<? echo $task; ?>.zip": </p>
    <p><input name="fil" type="file" />
	  <input name="submit" type="submit" value="Upload" /> 
	  <? 
		if($fname){ ?>
				<span class="style1">File stored as: <b><? echo substr(strrchr($fname, '/'), 1 );; ?></b></span>
			<?
		}
		?>
	</p>
    <p>&nbsp;</p>
</form>
<p>&nbsp;</p>
  <form id="form1" name="form1" method="post" action="index.php?ID=task_su&TASK=<? echo $task; ?>">
  <div align="left">
    <table width="647" border="0">
      <tr>
        <td width="126"><div align="right">
          <input type="submit" name="back" value="&lt;&lt; Back" />
        </div></td>
        <td width="63">
          <div align="left">
            <input type="submit" name="Submit" value="Next &gt;&gt;" />
        </div></td>
        <td width="10">&nbsp;</td>
        <td width="430"><strong>Step <? echo $counter; ?>/13 </strong>
		<? for($i = 0; $i < 13; $i++){
				
				if($i < $counter){
					?><img src="images/done.JPG" width="20" height="15" /><?
				}else{
					?><img src="images/unfinished.JPG" alt="uf2" width="21" height="15" /><?
				}
			}?></td>
      </tr>
    </table>
  </div>
</form>
<p align="right">&nbsp;</p>
<p>&nbsp;</p>

