<h2>2. Setting up the enviorment </h2>

<p>&nbsp;</p>
<p>During the experiment, the WSU Khepera Robot simulator will be used to simulate a safety-critical enviorment.</p>
<p><strong>Before for start, please download and install the emulator:</strong></p>
<ol>
  <li>Download ZIP packege from <a href="http://carl.cs.wright.edu/reg//ksim/downloads/downloads.html">http://carl.cs.wright.edu/reg//ksim/downloads/downloads.html</a>.</li>
  <li>Unzip the package on your prefered location.</li>
  <li>You now have a directory called &quot;WSU_KSuite_1.0&quot;, and a set of subdirectories and jar-files.</li>
</ol>
<p><strong>Import source files into your favorite Java editor:</strong></p>
<ol>
  <li>The &quot;src&quot; folder is where your Java source files should be stored. </li>
  <li>The &quot;controllers&quot; folder is where you put your compiled &quot;.class&quot; files when you are ready to run the emulator.</li>
  <li>The &quot;maps&quot; folder is where you put map simulations. </li>
</ol>
<p><strong>Try to compile and run the BallPicker example:</strong></p>
<ol>
  <li>Download <a href="./BallPicker.java">BallPicker.java</a>, and store it in the &quot;src&quot; directory.  </li>
  <li>Download <a href="./ball.map">ball.map</a>, and put it in the &quot;map&quot; directory. </li>
  <li>Compile BallPicker.java, and make sure that you get no error messages before you continue.</li>
  <li>Put the compiled class file &quot;BallPicker.class&quot; in the &quot;controllers&quot; directory.</li>
  <li>Run the Robot emulator by opening a console window and typing &quot;java -jar ksim.jar&quot;  in the &quot;WSU_KSuite_1.0&quot; directory.</li>
  <li>Load the map by pressing the &quot;Load&quot; button, and selecting the map-file <a href="./ball.map">ball.map</a>.</li>
  <li>Run the BallPicker controller example by pressing the &quot;Run&quot; button and selecting the &quot;BallPicker&quot; controller. </li>
</ol>
<p>Make sure your enviorment is correctly set up before you proceed! </p>
<p>&nbsp;</p>
<form id="form1" name="form1" method="post" action="index.php?ID=intro2">
  <label>

  <div align="left">
    <table width="647" border="0">
      <tr>
        <td width="126"><div align="right">
          <input type="submit" name="back" value="&lt;&lt; Back" />
        </div></td>
        <td width="63">
          <div align="left">
            <input type="submit" name="Submit" value="Next &gt;&gt;" />
        </div></td>
        <td width="10">&nbsp;</td>
        <td width="430"><strong>Step 2/13 </strong><img src="images/done.JPG" width="20" height="15" /><img src="images/done.JPG" width="20" height="15" /><img src="images/unfinished.JPG" alt="uf2" width="21" height="15" /><img src="images/unfinished.JPG" alt="uf3" width="21" height="15" /><img src="images/unfinished.JPG" alt="uf4" width="21" height="15" /><img src="images/unfinished.JPG" alt="uf5" width="21" height="15" /><img src="images/unfinished.JPG" alt="uf5" width="21" height="15" /><img src="images/unfinished.JPG" alt="uf5" width="21" height="15" /><img src="images/unfinished.JPG" alt="uf5" width="21" height="15" /><img src="images/unfinished.JPG" alt="uf5" width="21" height="15" /><img src="images/unfinished.JPG" alt="uf5" width="21" height="15" /><img src="images/unfinished.JPG" alt="uf5" width="21" height="15" /><img src="images/unfinished.JPG" alt="uf5" width="21" height="15" /></td>
      </tr>
    </table>
  </div>
  </label>
</form>
<p align="right">&nbsp;</p>
<p>&nbsp;</p>
<p>&nbsp;</p>
<p>&nbsp;</p>
