import edu.wsu.KheperaSimulator.RobotController;
import edu.wsu.KheperaSimulator.KSGripperStates;

public class Task1 extends RobotController 
{

	public Task1() 
	{
		
		setWaitTime(5);
	}

	public void doWork() throws Exception 
	{
		while(true) 
		{
			while(getDistanceValue(3) < 8 && getDistanceValue(4) < 8)
				goStraight();
			while(getDistanceValue(3) > 8 && getDistanceValue(4) < 8 && getDistanceValue(1) > 8) 
			{
				backStep();
				turnRight();
				turnRight();
				turnRight();
			}
		}
		//setFinished(true);
	}

	public void backStep() 
	{
		setMotorSpeeds(-3,-3);
	}

	public void stop()
	{
		setMotorSpeeds(0,0);
	}
	
	/**
	 * This method will make the robot turn right.
	 */
	public void turnRight()
	{
		setMotorSpeeds(3,-3);
	}
	
	/**
	 * This method will make the robot turn left.
	 */
	public void turnLeft()
	{
		setMotorSpeeds(-2,2);
	}
	
	/**
	 * This method will make the robot go straight ahead.
	 */
	public void goStraight()
	{
		setMotorSpeeds(4,4);
	}

	public void close() throws Exception{}

	protected void setFinished(boolean finished)
	{
		super.setFinished(finished);
	}

}


