import edu.wsu.KheperaSimulator.RobotController;
import edu.wsu.KheperaSimulator.KSGripperStates;


public class GateRobot extends RobotController {
	int facingLight = 100;
	boolean lookingAtGate = false;
	int distance=600;
	
	public void doWork(){
		if(obstructedFrontRight()){
			turnLeft();
		}else{
			goForward();
		}
	}
	
	public void close(){}
	
	public boolean obstructedFrontRight(){
		if(getDistanceValue(5) > distance || getDistanceValue(4) > distance || getDistanceValue(6) > distance)
			return true;
		else 
			return false;
	}
	
	public boolean obstructedFrontLeft(){
		if(getDistanceValue(3) > distance || getDistanceValue(2) > distance || getDistanceValue(1) > distance){
			return true;
		}else{
			return false;
		}
	}
	
	public void back(){
		setMotorSpeeds(-2,-2);
	}
	
	public void turnRight(){
		setMotorSpeeds(2,-2); 
	}
	
	public void turnLeft(){
		setMotorSpeeds(-2,2);
	}
	
	
	public void goForward(){
		setMotorSpeeds(2,2);
	}
	
}
