import edu.wsu.KheperaSimulator.KSGripperStates;
import edu.wsu.KheperaSimulator.RobotController;


public class task3 extends RobotController{

	public final int CRASH = 75;
	public final int WALL = 700;
	public boolean ballFound = false;
	
	public task3(){
		setWaitTime(5);
	}
		
	public void doWork() throws Exception {
		if(!ballFound){ //if ball not found, get closer
			moveToBall();
		}else{ // ball is close enough
			pickUpBall(); // Pick up the ball
			setFinished(true); // Task complete
		}
		
	}

	public void close() throws Exception {	
	}
	
	public void moveToBall(){
		if(getLightValue(6)>=CRASH && getLightValue(5)<=CRASH){
			turnLeft();
		}else if(getLightValue(7)<=CRASH && getLightValue(6)>=CRASH ||
				getDistanceValue(6)>=WALL && getDistanceValue(7)<=WALL){
			turnRight();
		}/*else if (getDistanceValue(2)>BALL_CLOSE && getLightValue(3)>BALL_CLOSE){
			stop();
			ballFound = true;
		}*/else{
			goStraight();
		}
		
	}
	
	public void stop(){
		setMotorSpeeds(0,0);
	}
	
	/**
	 * This method will make the robot turn right.
	 */
	public void turnRight(){
		setMotorSpeeds(2,-2);
	}
	
	/**
	 * This method will make the robot turn left.
	 */
	public void turnLeft(){
		setMotorSpeeds(-2,2);
	}
	
	/**
	 * This method will make the robot go straight ahead.
	 */
	public void goStraight(){
		setMotorSpeeds(2,2);
	}
	
	public void pickUpBall(){
		setGripperState(KSGripperStates.GRIP_OPEN); // Open gripper
		setArmState(KSGripperStates.ARM_DOWN); // Lower arms;
		sleep(100);		// wait 100ms
		setGripperState(KSGripperStates.GRIP_CLOSED); // Close gripper
		sleep(100);		// wait 100ms
		setArmState(KSGripperStates.ARM_UP); // lift arms;
		sleep(100);		// wait 100ms
	}

}
